import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 13,
  states: "#xQYQPOOOkQPO'#ChO!VQPO'#CmOOQO'#Cm'#CmQYQPOOO!tQPO,59PO!{QPO,59ROOQO-E6f-E6fOOQO1G.k1G.kO#QQPO1G.kO#XQPO1G.mO#^QPO1G.mOOQO7+$V7+$VO#cQPO7+$XO#kQPO7+$XOOQO-E6g-E6gOOQO1G.o1G.oOOQO<<Gs<<GsO#pQPO<<GsP#xQPO'#CiOOQOAN=_AN=_P#fQPO,59T",
  stateData: "#}~O`OSPOS~ORROSROTQOUROVRO~OYTOR[XS[XT[XU[XV[X^[XW[X~OcUORaXSaXTaXUaXVaXYaX^aXWaX~OWWO~PYOUYO~OW[O~PYOS]O~OU^O~ObaOd`O~OSbO~ObdOd`O~OSeO~O",
  goto: "!PbPPPPPPPPPcPcisPPPyXROSTXQSOSVSXRXTQZUR_ZXPOSTX",
  nodeNames: "⚠ LineComment Program Type String Attr Param Keyword } Application { Function",
  maxTerm: 20,
  skippedNodes: [0,1],
  repeatNodeCount: 2,
  tokenData: ".x~RhXY!mYZ!m]^!mpq!mrs#Ost#dxy#oyz#t|}#y!O!P$O!c!}$s#R#S%U#T#W%b#W#X%s#X#Y'r#Y#]%b#]#^)Z#^#b%b#b#c*r#c#e%b#e#f,Z#f#o%b#o#p.n#q#r.s~!rS`~XY!mYZ!m]^!mpq!m~#RSOr#Ors#_s#O#O#P~#O~#dOS~~#iQP~OY#dZ~#d~#tOc~~#yOb~~$OOd~~$RP!O!P$U~$XP!O!P$[~$_Ppq$b~$eP#c#d$h~$kP#b#c$n~$sOV~~$xSR~!Q![$s!c!}$s#R#S$s#T#o$s~%XP#R#S%[~%_P#T#o%b~%gST~!Q![%b!c!}%b#R#S%b#T#o%b~%xTT~!Q![%b!c!}%b#R#S%b#T#U&X#U#o%b~&^UT~!Q![%b!c!}%b#R#S%b#T#h%b#h#i&p#i#o%b~&uUT~!Q![%b!c!}%b#R#S%b#T#X%b#X#Y'X#Y#o%b~'^TT~!Q![%b![!]'m!c!}%b#R#S%b#T#o%b~'rOU~~'wUT~!Q![%b!c!}%b#R#S%b#T#b%b#b#c(Z#c#o%b~(`UT~!Q![%b!c!}%b#R#S%b#T#W%b#W#X(r#X#o%b~(wUT~!Q![%b!c!f%b!f!g%s!g!}%b#R#S%b#T#o%b~)`UT~!Q![%b!c!}%b#R#S%b#T#b%b#b#c)r#c#o%b~)wUT~!Q![%b!c!}%b#R#S%b#T#]%b#]#^*Z#^#o%b~*`UT~!Q![%b!c!}%b#R#S%b#T#h%b#h#i(r#i#o%b~*wUT~!Q![%b!c!}%b#R#S%b#T#X%b#X#Y+Z#Y#o%b~+`UT~!Q![%b!c!}%b#R#S%b#T#a%b#a#b+r#b#o%b~+wUT~!Q![%b!c!}%b#R#S%b#T#c%b#c#d'X#d#o%b~,`UT~!Q![%b!c!}%b#R#S%b#T#i%b#i#j,r#j#o%b~,wUT~!Q![%b!c!}%b#R#S%b#T#X%b#X#Y-Z#Y#o%b~-`UT~!Q![%b!c!}%b#R#S%b#T#f%b#f#g-r#g#o%b~-wUT~!Q![%b!c!}%b#R#S%b#T#m%b#m#n.Z#n#o%b~.bSV~T~!Q![%b!c!}%b#R#S%b#T#o%b~.sOY~~.xOW~",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const graphiQLLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false })
            }),
            foldNodeProp.add({
                Application: foldInside
            }),
            styleTags({
                Type: tags.className,
                Attr: tags.variableName,
                String: tags.string,
                Keyword: tags.keyword,
                Param: tags.typeName,
                LineComment: tags.lineComment,
                "{ }": tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: "" }
    }
});
function graphiQL() {
    return new LanguageSupport(graphiQLLanguage);
}

export { graphiQL, graphiQLLanguage };
